## yder 1.4.11

=== CMakeLists.txt ===
#
# Yder library
#
# CMake file used to build all programs
#
# Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
# Copyright 2018-2020 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(yder C)

set(CMAKE_C_STANDARD 99)
if (NOT MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")
endif()

# library info

set(PROJECT_DESCRIPTION "Logging library for C applications")
set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/yder/")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/yder/issues")
set(LIBRARY_VERSION_MAJOR "1")
set(LIBRARY_VERSION_MINOR "4")
set(LIBRARY_VERSION_PATCH "11")

set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(PROJECT_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(PROJECT_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (${LIBRARY_VERSION_MAJOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MAJOR_PAD "0${LIBRARY_VERSION_MAJOR}")
else ()
    set (LIBRARY_VERSION_MAJOR_PAD "${LIBRARY_VERSION_MAJOR}")
endif ()
if (${LIBRARY_VERSION_MINOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MINOR_PAD "0${LIBRARY_VERSION_MINOR}")
else ()
    set (LIBRARY_VERSION_MINOR_PAD "${LIBRARY_VERSION_MINOR}")
endif ()
if (${LIBRARY_VERSION_PATCH} VERSION_LESS 10)
    set (LIBRARY_VERSION_PATCH_PAD "0${LIBRARY_VERSION_PATCH}")
else ()
    set (LIBRARY_VERSION_PATCH_PAD "${LIBRARY_VERSION_PATCH}")
endif ()
set(PROJECT_VERSION_NUMBER "${LIBRARY_VERSION_MAJOR_PAD}${LIBRARY_VERSION_MINOR_PAD}${LIBRARY_VERSION_PATCH_PAD}")

set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
set(ORCANIA_VERSION_REQUIRED "2.1.1")

# cmake modules

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)

include(GNUInstallDirs)
include(CheckSymbolExists)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()

# directories and source

set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)

include_directories(${INC_DIR})

set(LIB_SRC
        ${INC_DIR}/yder.h # allow many IDEs to find and edit it
        ${SRC_DIR}/yder.c)

# dependencies

option(WITH_JOURNALD "Check journald." ON)

if (WITH_JOURNALD)
  include(FindSystemd)
  find_package(Systemd REQUIRED)
  if (SYSTEMD_FOUND)
      set(SYSTEMD_LIBRARIES systemd)
      include_directories(${SYSTEMD_INCLUDE_DIRS})
      set(Y_DISABLE_JOURNALD OFF)
  endif ()
else()
  set(Y_DISABLE_JOURNALD ON)
endif ()

# shared library

add_library(yder SHARED ${LIB_SRC})
if (NOT MSVC)
    set_target_properties(yder PROPERTIES
            COMPILE_OPTIONS -Wextra
            PUBLIC_HEADER "${INC_DIR}/yder.h;${PROJECT_BINARY_DIR}/yder-cfg.h"
            VERSION "${LIBRARY_VERSION}"
            SOVERSION "${LIBRARY_SOVERSION}")
endif()
if (WIN32)
    set_target_properties(yder PROPERTIES SUFFIX "-${LIBRARY_VERSION_MAJOR}.dll")
endif ()

# static library

option(BUILD_STATIC "Build static library." OFF)

if (BUILD_STATIC)
    add_library(yder_static STATIC ${LIB_SRC})
    target_compile_definitions(yder_static PUBLIC -DO_STATIC_LIBRARY)
    set_target_properties(yder_static PROPERTIES
            OUTPUT_NAME yder)
endif ()

option(DOWNLOAD_DEPENDENCIES "Download required dependencies" ON)

option(SEARCH_ORCANIA "Search for Orcania library" ON)
if (SEARCH_ORCANIA)
    set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
    include(FindOrcania)
    find_package(Orcania ${ORCANIA_VERSION_REQUIRED} QUIET) # try to find orcania
    if (NOT ORCANIA_FOUND)
        if (DOWNLOAD_DEPENDENCIES)
            include(DownloadProject)
            download_project(PROJ orcania # ... otherwise, download archive
                URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
                QUIET)
            add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
            include_directories(${orcania_SOURCE_DIR}/include)
            include_directories(${orcania_BINARY_DIR})
            add_dependencies(yder orcania)
            set(ORCANIA_LIBRARIES orcania)
            set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
        else ()
            message( FATAL_ERROR "Orcania not found")
        endif ()
    else()
        set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
        include_directories(${ORCANIA_INCLUDE_DIRS})
        include_directories(${orcania_BINARY_DIR})
    endif ()
endif ()

target_link_libraries(yder ${LIBS} ${ORCANIA_LIBRARIES} ${SYSTEMD_LIBRARIES})

if (WITH_JOURNALD)
  set(PKGCONF_REQ "")
  set(PKGCONF_REQ_PRIVATE "libsystemd, liborcania")
else ()
  set(PKGCONF_REQ "")
  set(PKGCONF_REQ_PRIVATE "liborcania")
endif ()

# documentation

option(BUILD_YDER_DOCUMENTATION "Build the documentation." OFF)
if (BUILD_YDER_DOCUMENTATION)
    find_package(Doxygen)
    if (DOXYGEN_FOUND)
        set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen.cfg)
        set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)
        
        configure_file(${doxyfile_in} ${doxyfile} @ONLY)
        
        add_custom_target(doc
                          COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile_in}
                          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                          COMMENT "Generating documentation with Doxygen"
                          VERBATIM)

    else ()
        message(FATAL_ERROR "Doxygen is needed to build the documentation.")
    endif ()
endif ()

# build yder-cfg.h file
configure_file(${INC_DIR}/yder-cfg.h.in ${PROJECT_BINARY_DIR}/yder-cfg.h)
set (CMAKE_EXTRA_INCLUDE_FILES ${PROJECT_BINARY_DIR})
include_directories(${PROJECT_BINARY_DIR})

# tests

option(BUILD_YDER_TESTING "Build the testing tree." OFF) # because we don not use include(CTest)

if (BUILD_YDER_TESTING)
    include(FindCheck)
    find_package(Check)
    if (CHECK_FOUND)
        if (NOT WIN32 AND NOT APPLE)
            include(FindSubunit)
            find_package(Subunit REQUIRED)
        endif ()

        enable_testing()

        set(CMAKE_CTEST_COMMAND ctest -V)

        set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
        set(LIBS yder ${LIBS} ${CHECK_LIBRARIES} ${ORCANIA_LIBRARIES})
        if (NOT WIN32)
            find_package(Threads REQUIRED)
            set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT} m)
        endif ()
        if (NOT APPLE)
            set(LIBS ${LIBS} rt)
        endif ()
        if (NOT WIN32 AND NOT APPLE)
            set(LIBS ${LIBS} ${SUBUNIT_LIBRARIES})
        endif ()

        set(TESTS yder_test)

        configure_file(
                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
                "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
                @ONLY)

        foreach (t ${TESTS})
            add_executable(${t} EXCLUDE_FROM_ALL ${TST_DIR}/${t}.c)
            target_include_directories(${t} PUBLIC ${TST_DIR})
            target_link_libraries(${t} PUBLIC ${LIBS})
            add_test(NAME ${t}
                    WORKING_DIRECTORY ${TST_DIR}
                    COMMAND ${t})
        endforeach ()
    endif ()
endif ()

# install target

option(INSTALL_HEADER "Install the header files" ON) # Install yder.h or not

configure_file(libyder.pc.in libyder.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libyder.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

set(TARGETS yder)
if (BUILD_STATIC)
    set(TARGETS ${TARGETS} yder_static)
endif ()

if (INSTALL_HEADER)
    install(TARGETS ${TARGETS}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
    install(DIRECTORY examples/
            DESTINATION ${CMAKE_INSTALL_DOCDIR}/examples/ COMPONENT runtime)
    install(FILES README.md
            DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT runtime)
else ()
    install(TARGETS ${TARGETS}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif ()

# uninstall target

if (NOT TARGET uninstall)
    configure_file(
            "${CMAKE_MODULE_PATH}/CMakeUninstall.cmake.in"
            "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
            IMMEDIATE @ONLY)
    add_custom_target(uninstall
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif ()

# packaging

set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (INSTALL_HEADER)
    set(PACKAGE_FILE_NAME
            "lib${CMAKE_PROJECT_NAME}-dev_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
else ()
    set(PACKAGE_FILE_NAME
            "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
endif ()
set(PACKAGE_IGNORED_FILES
        "${CMAKE_CURRENT_BINARY_DIR}/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")

set(CPACK_PACKAGE_NAME "libyder")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Logging library for C applications")
set(CPACK_GENERATOR "TGZ;DEB")
set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

option(BUILD_RPM "Build a RPM for your system" OFF)
if (BUILD_RPM)
  set(CPACK_GENERATOR "TGZ;DEB;RPM")
  set(CPACK_RPM_PACKAGE_LICENSE "LGPL")
  set(CPACK_RPM_PACKAGE_URL "http://babelouest.github.io/yder/")
endif ()

set(CPACK_DEBIAN_PACKAGE_MAINTAINER "mail@babelouest.org")

set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.4), liborcania (>= ${ORCANIA_VERSION_REQUIRED})")
if (INSTALL_HEADER)
  if (WITH_SYSTEMD)
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libsystemd-dev")
  endif ()
else ()
  if (WITH_SYSTEMD)
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libsystemd0")
  endif ()
endif ()

set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
set(CPACK_SOURCE_IGNORE_FILES ${PACKAGE_IGNORED_FILES})

include(CPack)

add_custom_target(dist_y
        COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

message(STATUS "Journald support: ${WITH_JOURNALD}")
message(STATUS "Build static library: ${BUILD_STATIC}")
message(STATUS "Build testing tree: ${BUILD_YDER_TESTING}")
message(STATUS "Install the header files: ${INSTALL_HEADER}")
message(STATUS "Build RPM package: ${BUILD_RPM}") 
message(STATUS "Build documentation: ${BUILD_YDER_DOCUMENTATION}")

=== src/Makefile ===
#
# Yder Framework
#
# Makefile used to build the software
#
# Copyright 2015-2020 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
PROJECT_NAME=yder
PROJECT_DESCRIPTION=Logging library for C applications
PROJECT_BUGREPORT_PATH=https://github.com/babelouest/yder/issues
PKGCONF_REQ=
PKGCONF_REQ_PRIVATE=
DESTDIR=/usr/local
YDER_INCLUDE=../include
CONFIG_TEMPLATE=$(YDER_INCLUDE)/yder-cfg.h.in
CONFIG_FILE=$(YDER_INCLUDE)/yder-cfg.h
PKGCONFIG_FILE=../libyder.pc
PKGCONFIG_TEMPLATE=../libyder.pc.in
CC=gcc
CFLAGS+=-c -fPIC -Wall -Werror -Wextra -D_REENTRANT -I$(YDER_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
LIBS=-lc -lorcania $(ADDITIONALLIBS)
OUTPUT=libyder.so
VERSION_MAJOR=1
VERSION_MINOR=4
VERSION_PATCH=11

SONAME = -soname
ifeq ($(shell uname -s),Darwin)
	SONAME = -install_name
endif

ifndef Y_DISABLE_JOURNALD
	DISABLE_JOURNALD=0
	LIBS+=-lsystemd
else
	DISABLE_JOURNALD=1
endif

all: release

$(CONFIG_FILE):
	@cp $(CONFIG_TEMPLATE) $(CONFIG_FILE)
	@echo Config file $(CONFIG_FILE) generated 
	@sed -i -e 's/$${PROJECT_VERSION}/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_MAJOR}/$(VERSION_MAJOR)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_MINOR}/$(VERSION_MINOR)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_PATCH}/$(VERSION_PATCH)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_NUMBER}/$(shell printf '%02d' $(VERSION_MAJOR))$(shell printf '%02d' $(VERSION_MINOR))$(shell printf '%02d' $(VERSION_PATCH))/g' $(CONFIG_FILE)        
	@if [ "$(DISABLE_JOURNALD)" = "1" ]; then \
		echo "JOURNALD SUPPORT DISABLED"; \
		sed -i -e 's/\#cmakedefine Y_DISABLE_JOURNALD/\#define Y_DISABLE_JOURNALD/g' $(CONFIG_FILE); \
	else \
		echo "JOURNALD SUPPORT ENABLED"; \
		sed -i -e 's/\#cmakedefine Y_DISABLE_JOURNALD/\/* #undef Y_DISABLE_JOURNALD *\//g' $(CONFIG_FILE); \
	fi

$(PKGCONFIG_FILE):
	@cp $(PKGCONFIG_TEMPLATE) $(PKGCONFIG_FILE)
	@echo Pkgconfig file $(PKGCONFIG_FILE) generated
	@sed -i -e 's#@CMAKE_INSTALL_PREFIX@#$(DESTDIR)#g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@CMAKE_INSTALL_LIBDIR@/lib/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@CMAKE_INSTALL_INCLUDEDIR@/include/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_NAME@/$(PROJECT_NAME)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_DESCRIPTION@/$(PROJECT_DESCRIPTION)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's|@PROJECT_BUGREPORT_PATH@|$(PROJECT_BUGREPORT_PATH)|g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@LIBRARY_VERSION@/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ@/$(PKGCONF_REQ)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ_PRIVATE@/$(PKGCONF_REQ_PRIVATE)/g' $(PKGCONFIG_FILE)

libyder.so: yder.o
	$(CC) -shared -fPIC -Wl,$(SONAME),$(OUTPUT) -o $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) yder.o $(LIBS) $(LDFLAGS)
	ln -sf $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OUTPUT)

libyder.a: yder.o
	ar rcs libyder.a yder.o

yder.o: $(CONFIG_FILE) $(YDER_INCLUDE)/yder.h yder.c
	$(CC) $(CFLAGS) yder.c

clean:
	rm -f *.o *.so *.a $(OUTPUT) $(PKGCONFIG_FILE) $(OUTPUT).* $(YDER_INCLUDE)/yder-cfg.h

install: all $(PKGCONFIG_FILE)
	install $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(DESTDIR)/lib
	mkdir -p $(DESTDIR)/lib/pkgconfig/
	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig/
	install -m644 $(YDER_INCLUDE)/yder.h $(DESTDIR)/include
	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
	-ldconfig $(DESTDIR)/lib

static-install: static
	install libyder.a $(DESTDIR)/lib
	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig
	install -m644 $(YDER_INCLUDE)/yder.h $(DESTDIR)/include
	install -m644 $(CONFIG_FILE) $(DESTDIR)/include

uninstall:
	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/libyder.a
	rm -f $(DESTDIR)/lib/$(OUTPUT).*
	rm -f $(DESTDIR)/include/yder.h
	rm -f $(DESTDIR)/include/$(CONFIG_FILE)
	rm -f $(DESTDIR)/lib/pkgconfig/$(PKGCONFIG_FILE)

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libyder.so

release: ADDITIONALFLAGS=-O3

release: libyder.so

static-debug: ADDITIONALFLAGS=-DDEBUG -g -O0

static-debug: libyder.a

static: ADDITIONALFLAGS=-O3

static: libyder.a

=== debian/changelog ===
yder (1.4.11-1) unstable; urgency=medium

  * New upstream release
  * d/rules: avoid downloading dependencies if not found
  * d/patches: disable doc patch
  * d/copyright: update copyright

 -- Nicolas Mora <babelouest@debian.org>  Wed, 08 Jul 2020 23:24:58 -0400

yder (1.4.10-5) unstable; urgency=medium

  * d/control: use debhelper-compat
  * d/control: set debhelper-control version to 13
  * d/tests/control: cleanup test builder
  * d/control: Add Rules-Requires-Root field

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 28 Jun 2020 20:37:08 -0400

yder (1.4.10-4) unstable; urgency=medium

  * Upload to unstable
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 27 Jun 2020 11:41:21 -0400

yder (1.4.10-3) experimental; urgency=medium

  * d/rules: build documentation using doxygen
  * d/libyder-dev.docs: install documentation
  * d/copyright: fix maintainer e-mail address

 -- Nicolas Mora <nicolas@babelouest.org>  Fri, 03 Apr 2020 17:17:43 -0400

yder (1.4.10-2) experimental; urgency=medium

  * debian/control: specify orcania version
  * debian/control: ugrade compat version to 12

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 31 Mar 2020 21:19:34 -0400

yder (1.4.10-1) experimental; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.5.0 (no changes)
  * debian/copyright: update forgotten copyright mention

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 28 Mar 2020 08:34:18 -0400

=== debian/control ===
Source: yder
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
          , Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
	, autopkgtest (>= 5.6~)
	, dh-exec
	, liborcania-dev
	, libsystemd-dev [linux-any]
	, cmake
	, check
	, doxygen
Standards-Version: 4.5.0
Homepage: https://github.com/babelouest/yder
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/yder.git
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/yder.git
Rules-Requires-Root: no

Package: libyder2.0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: logging library written in C
 Simple and easy to use logging library. You can log messages to the
 console, a file or syslog.
 .
 Yder is mono-thread, which mean that you can use only one instance
 of yder log at the same time in your program.

Package: libyder-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libyder2.0 (= ${binary:Version})
	, ${misc:Depends}
	, liborcania-dev
	, libsystemd-dev [linux-any]
Description: logging library written in C - development
 Simple and easy to use logging library. You can log messages to the
 console, a file or syslog.
 .
 Yder is mono-thread, which mean that you can use only one instance
 of yder log at the same time in your program.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

ifneq ($(DEB_HOST_ARCH_OS),linux)
ARGS += -DWITH_JOURNALD=OFF
else
ARGS += -DWITH_JOURNALD=ON
endif

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_install:
	echo dh_auto_install

override_dh_auto_configure:
	dh_auto_configure -- $(ARGS) -DBUILD_YDER_TESTING=ON \
                               -DINSTALL_HEADER=ON \
                               -DDOWNLOAD_DEPENDENCIES=OFF \
                               --no-warn-unused-cli
	dh_installexamples --

override_dh_auto_build:
	doxygen doc/doxygen.cfg
	dh_auto_build --

## yder 1.4.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,7 +30,7 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/yder/issues")
 set(LIBRARY_VERSION_MAJOR "1")
 set(LIBRARY_VERSION_MINOR "4")
-set(LIBRARY_VERSION_PATCH "11")
+set(LIBRARY_VERSION_PATCH "12")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})

=== src/Makefile ===
--- 
+++ 
@@ -35,7 +35,7 @@
 OUTPUT=libyder.so
 VERSION_MAJOR=1
 VERSION_MINOR=4
-VERSION_PATCH=11
+VERSION_PATCH=12
 
 SONAME = -soname
 ifeq ($(shell uname -s),Darwin)

=== test/Makefile ===
#
# Public domain, no copyright. Use at your own risk.
#

CC=gcc
CFLAGS+=-Wall -D_REENTRANT -DDEBUG -g -O0 -I$(INCLUDE_LOCATION) $(CPPFLAGS)
YDER_LOCATION=../src
INCLUDE_LOCATION=../include
LIBS=-lc -lorcania -lyder $(shell pkg-config --libs check) -L$(YDER_LOCATION)

all: test

clean:
	rm -f *.o yder_test valgrind.txt

libyder.so:
	cd $(YDER_LOCATION) && $(MAKE) debug

yder_test: yder_test.c
	$(CC) $(CFLAGS) yder_test.c -o yder_test $(LIBS)

test_yder_test: libyder.so yder_test
	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} ./yder_test

test: test_yder_test

memcheck: yder_test
	LD_LIBRARY_PATH=$(YDER_LOCATION):${LD_LIBRARY_PATH} valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./yder_test 2>valgrind.txt

=== debian/changelog ===
yder (1.4.12-1) unstable; urgency=medium

  * d/control: Remove dh-exec from builddep
  * d/rules: enable dh_install
  * d/*.install: Do not use dh-exec

 -- Nicolas Mora <babelouest@debian.org>  Thu, 03 Sep 2020 07:51:17 -0400

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,6 @@
           , Nicolas Mora <babelouest@debian.org>
 Build-Depends: debhelper-compat (= 13)
 	, autopkgtest (>= 5.6~)
-	, dh-exec
 	, liborcania-dev
 	, libsystemd-dev [linux-any]
 	, cmake

## yder 1.4.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,7 +30,7 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/yder/issues")
 set(LIBRARY_VERSION_MAJOR "1")
 set(LIBRARY_VERSION_MINOR "4")
-set(LIBRARY_VERSION_PATCH "12")
+set(LIBRARY_VERSION_PATCH "14")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
@@ -56,7 +56,7 @@
 
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
-set(ORCANIA_VERSION_REQUIRED "2.1.1")
+set(ORCANIA_VERSION_REQUIRED "2.2.1")
 
 # cmake modules

=== Makefile ===
#
# Example program
#
# Makefile used to build all programs
#
# Copyright 2014-2020 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.  If not, see <http://www.gnu.org/licenses/>.
#

LIBYDER_LOCATION=./src
EXAMPLE_LOCATION=./examples
TEST_LOCATION=./test

all: release

debug:
	cd $(LIBYDER_LOCATION) && $(MAKE) debug $*

install:
	cd $(LIBYDER_LOCATION) && $(MAKE) install

clean:
	cd $(LIBYDER_LOCATION) && $(MAKE) clean
	cd $(EXAMPLE_LOCATION) && $(MAKE) clean
	cd $(TEST_LOCATION) && $(MAKE) clean

check:
	cd $(TEST_LOCATION) && $(MAKE) test

release:
	cd $(LIBYDER_LOCATION) && $(MAKE)

log_console:
	cd $(EXAMPLE_LOCATION) && $(MAKE) log_console

log_file:
	cd $(EXAMPLE_LOCATION) && $(MAKE) log_file

log_syslog:
	cd $(EXAMPLE_LOCATION) && $(MAKE) log_syslog

log_combined:
	cd $(EXAMPLE_LOCATION) && $(MAKE) log_combined

doxygen:
	doxygen doc/doxygen.cfg

=== src/Makefile ===
--- 
+++ 
@@ -31,11 +31,11 @@
 PKGCONFIG_TEMPLATE=../libyder.pc.in
 CC=gcc
 CFLAGS+=-c -fPIC -Wall -Werror -Wextra -D_REENTRANT -I$(YDER_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
-LIBS=-lc -lorcania $(ADDITIONALLIBS)
+LIBS=-lc -lorcania
 OUTPUT=libyder.so
 VERSION_MAJOR=1
 VERSION_MINOR=4
-VERSION_PATCH=12
+VERSION_PATCH=14
 
 SONAME = -soname
 ifeq ($(shell uname -s),Darwin)
@@ -44,7 +44,7 @@
 
 ifndef Y_DISABLE_JOURNALD
 	DISABLE_JOURNALD=0
-	LIBS+=-lsystemd
+	LIBSYSTEMD=-lsystemd
 else
 	DISABLE_JOURNALD=1
 endif
@@ -79,12 +79,13 @@
 	@sed -i -e 's/@LIBRARY_VERSION@/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(PKGCONFIG_FILE)
 	@sed -i -e 's/@PKGCONF_REQ@/$(PKGCONF_REQ)/g' $(PKGCONFIG_FILE)
 	@sed -i -e 's/@PKGCONF_REQ_PRIVATE@/$(PKGCONF_REQ_PRIVATE)/g' $(PKGCONFIG_FILE)
+	@sed -i -e 's/@LIB_STATIC@/$(LIB_STATIC)/g' $(PKGCONFIG_FILE)
 
-libyder.so: yder.o
-	$(CC) -shared -fPIC -Wl,$(SONAME),$(OUTPUT) -o $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) yder.o $(LIBS) $(LDFLAGS)
+libyder.so: yder.o $(PKGCONFIG_FILE)
+	$(CC) -shared -fPIC -Wl,$(SONAME),$(OUTPUT) -o $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) yder.o $(LIBS) $(LIBSYSTEMD) $(LDFLAGS)
 	ln -sf $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OUTPUT)
 
-libyder.a: yder.o
+libyder.a: yder.o $(PKGCONFIG_FILE)
 	ar rcs libyder.a yder.o
 
 yder.o: $(CONFIG_FILE) $(YDER_INCLUDE)/yder.h yder.c
@@ -93,9 +94,9 @@
 clean:
 	rm -f *.o *.so *.a $(OUTPUT) $(PKGCONFIG_FILE) $(OUTPUT).* $(YDER_INCLUDE)/yder-cfg.h
 
-install: all $(PKGCONFIG_FILE)
+install: all
 	install $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(DESTDIR)/lib
-	mkdir -p $(DESTDIR)/lib/pkgconfig/
+	mkdir -p $(DESTDIR)/lib/pkgconfig/ $(DESTDIR)/include
 	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig/
 	install -m644 $(YDER_INCLUDE)/yder.h $(DESTDIR)/include
 	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
@@ -103,6 +104,7 @@
 
 static-install: static
 	install libyder.a $(DESTDIR)/lib
+	mkdir -p $(DESTDIR)/lib/pkgconfig/ $(DESTDIR)/include
 	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig
 	install -m644 $(YDER_INCLUDE)/yder.h $(DESTDIR)/include
 	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
@@ -130,3 +132,5 @@
 
 static: libyder.a
 
+static: LIB_STATIC=$(LIBSYSTEMD)
+

=== debian/changelog ===
yder (1.4.14-1ubuntu2) impish; urgency=medium

  * Back in sync with Debian

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 05 Oct 2021 08:50:55 +0200

yder (1.4.14-1) unstable; urgency=medium

  * New upstream release
  * d/control: upgrade standards version to 4.6.0
  * d/copyright: remove superfluous file

 -- Nicolas Mora <babelouest@debian.org>  Wed, 15 Sep 2021 07:19:10 -0400

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 	, cmake
 	, check
 	, doxygen
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://github.com/babelouest/yder
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/yder.git
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/yder.git

## yder 1.4.17

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # CMake file used to build all programs
 #
 # Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
-# Copyright 2018-2020 Nicolas Mora <mail@babelouest.org>
+# Copyright 2018-2022 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the MIT License
@@ -30,7 +30,7 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/yder/issues")
 set(LIBRARY_VERSION_MAJOR "1")
 set(LIBRARY_VERSION_MINOR "4")
-set(LIBRARY_VERSION_PATCH "14")
+set(LIBRARY_VERSION_PATCH "17")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
@@ -56,11 +56,12 @@
 
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
-set(ORCANIA_VERSION_REQUIRED "2.2.1")
+set(ORCANIA_VERSION_REQUIRED "2.3.0")
 
 # cmake modules
 
-set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
+set(Y_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
+list(APPEND CMAKE_MODULE_PATH "${Y_CMAKE_MODULE_PATH}")
 
 include(GNUInstallDirs)
 include(CheckSymbolExists)
@@ -155,6 +156,7 @@
             message( FATAL_ERROR "Orcania not found")
         endif ()
     else()
+        message(STATUS "Orcania found")
         set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
         include_directories(${ORCANIA_INCLUDE_DIRS})
         include_directories(${orcania_BINARY_DIR})
@@ -231,7 +233,7 @@
         set(TESTS yder_test)
 
         configure_file(
-                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
+                "${Y_CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
                 "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
                 @ONLY)
 
@@ -249,6 +251,18 @@
 # install target
 
 option(INSTALL_HEADER "Install the header files" ON) # Install yder.h or not
+
+if(IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}")
+  set(PKGCONFIG_TARGET_INCLUDES "${CMAKE_INSTALL_INCLUDEDIR}")
+else()
+  set(PKGCONFIG_TARGET_INCLUDES "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
+endif()
+
+if(IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}")
+  set(PKGCONFIG_TARGET_LIBDIR "${CMAKE_INSTALL_LIBDIR}")
+else()
+  set(PKGCONFIG_TARGET_LIBDIR "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
+endif()
 
 configure_file(libyder.pc.in libyder.pc @ONLY)
 
@@ -281,7 +295,7 @@
 
 if (NOT TARGET uninstall)
     configure_file(
-            "${CMAKE_MODULE_PATH}/CMakeUninstall.cmake.in"
+            "${Y_CMAKE_MODULE_PATH}/CMakeUninstall.cmake.in"
             "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
             IMMEDIATE @ONLY)
     add_custom_target(uninstall

=== src/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # Makefile used to build the software
 #
-# Copyright 2015-2020 Nicolas Mora <mail@babelouest.org>
+# Copyright 2015-2022 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public License
@@ -35,7 +35,7 @@
 OUTPUT=libyder.so
 VERSION_MAJOR=1
 VERSION_MINOR=4
-VERSION_PATCH=14
+VERSION_PATCH=17
 
 SONAME = -soname
 ifeq ($(shell uname -s),Darwin)
@@ -71,8 +71,8 @@
 	@cp $(PKGCONFIG_TEMPLATE) $(PKGCONFIG_FILE)
 	@echo Pkgconfig file $(PKGCONFIG_FILE) generated
 	@sed -i -e 's#@CMAKE_INSTALL_PREFIX@#$(DESTDIR)#g' $(PKGCONFIG_FILE)
-	@sed -i -e 's/@CMAKE_INSTALL_LIBDIR@/lib/g' $(PKGCONFIG_FILE)
-	@sed -i -e 's/@CMAKE_INSTALL_INCLUDEDIR@/include/g' $(PKGCONFIG_FILE)
+	@sed -i -e 's#@PKGCONFIG_TARGET_LIBDIR@#$${prefix}/lib#g' $(PKGCONFIG_FILE)
+	@sed -i -e 's#@PKGCONFIG_TARGET_INCLUDES@#$${prefix}/include#g' $(PKGCONFIG_FILE)
 	@sed -i -e 's/@PROJECT_NAME@/$(PROJECT_NAME)/g' $(PKGCONFIG_FILE)
 	@sed -i -e 's/@PROJECT_DESCRIPTION@/$(PROJECT_DESCRIPTION)/g' $(PKGCONFIG_FILE)
 	@sed -i -e 's|@PROJECT_BUGREPORT_PATH@|$(PROJECT_BUGREPORT_PATH)|g' $(PKGCONFIG_FILE)

=== debian/changelog ===
yder (1.4.17-1) unstable; urgency=medium

  * New upstream release
  * d/symbols: Add symbol y_set_split_message_newline

 -- Nicolas Mora <babelouest@debian.org>  Wed, 01 Jun 2022 19:00:28 -0400

yder (1.4.15-2) unstable; urgency=medium

  * d/control: Add version required for liborcania

 -- Nicolas Mora <babelouest@debian.org>  Mon, 18 Apr 2022 16:49:03 -0400

yder (1.4.15-1) unstable; urgency=medium

  * New upstream release
  * d/copyright: update years
  * d/not-installed: do not install .gitignore files

 -- Nicolas Mora <babelouest@debian.org>  Mon, 11 Apr 2022 19:54:45 -0400

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
           , Nicolas Mora <babelouest@debian.org>
 Build-Depends: debhelper-compat (= 13)
 	, autopkgtest (>= 5.6~)
-	, liborcania-dev
+	, liborcania-dev (>= 2.2.2)
 	, libsystemd-dev [linux-any]
 	, cmake
 	, check
@@ -35,7 +35,7 @@
 Section: libdevel
 Depends: libyder2.0 (= ${binary:Version})
 	, ${misc:Depends}
-	, liborcania-dev
+	, liborcania-dev (>= 2.2.2)
 	, libsystemd-dev [linux-any]
 Description: logging library written in C - development
  Simple and easy to use logging library. You can log messages to the

## yder 1.4.19

=== CMakeLists.txt ===
#
# Yder library
#
# CMake file used to build all programs
#
# Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
# Copyright 2018-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(yder C)

set(CMAKE_C_STANDARD 99)
if (NOT MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")
endif()

# library info

set(PROJECT_DESCRIPTION "Logging library for C applications")
set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/yder/")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/yder/issues")
set(LIBRARY_VERSION_MAJOR "1")
set(LIBRARY_VERSION_MINOR "4")
set(LIBRARY_VERSION_PATCH "19")

set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(PROJECT_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(PROJECT_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (${LIBRARY_VERSION_MAJOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MAJOR_PAD "0${LIBRARY_VERSION_MAJOR}")
else ()
    set (LIBRARY_VERSION_MAJOR_PAD "${LIBRARY_VERSION_MAJOR}")
endif ()
if (${LIBRARY_VERSION_MINOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MINOR_PAD "0${LIBRARY_VERSION_MINOR}")
else ()
    set (LIBRARY_VERSION_MINOR_PAD "${LIBRARY_VERSION_MINOR}")
endif ()
if (${LIBRARY_VERSION_PATCH} VERSION_LESS 10)
    set (LIBRARY_VERSION_PATCH_PAD "0${LIBRARY_VERSION_PATCH}")
else ()
    set (LIBRARY_VERSION_PATCH_PAD "${LIBRARY_VERSION_PATCH}")
endif ()
set(PROJECT_VERSION_NUMBER "${LIBRARY_VERSION_MAJOR_PAD}${LIBRARY_VERSION_MINOR_PAD}${LIBRARY_VERSION_PATCH_PAD}")

set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
set(ORCANIA_VERSION_REQUIRED "2.3.2")

# cmake modules

set(Y_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
list(APPEND CMAKE_MODULE_PATH "${Y_CMAKE_MODULE_PATH}")

include(GNUInstallDirs)
include(CheckSymbolExists)
include(CMakePackageConfigHelpers)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()

# directories and source

set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)

include_directories(${INC_DIR})

set(LIB_SRC
        ${INC_DIR}/yder.h # allow many IDEs to find and edit it
        ${SRC_DIR}/yder.c)

# dependencies

set(WITH_JOURNALD_DEFAULT ON)
if(WIN32)
    set(WITH_JOURNALD_DEFAULT OFF)
endif()
option(WITH_JOURNALD "Check journald." ${WITH_JOURNALD_DEFAULT})

if (WITH_JOURNALD)
  find_package(Systemd REQUIRED)
  set(SYSTEMD_LIBRARIES Systemd::Systemd)
  set(Y_DISABLE_JOURNALD OFF)
else()
  set(Y_DISABLE_JOURNALD ON)
  set(SYSTEMD_LIBRARIES )
endif ()

option(BUILD_SHARED "Build shared library." ON)
option(BUILD_STATIC "Build static library." OFF)

if (NOT BUILD_SHARED AND NOT BUILD_STATIC)
    message(FATAL_ERROR "BUILD_SHARED and BUILD_STATIC cannot be both disabled")
endif ()

# static library

if (BUILD_STATIC)
    add_library(yder_static STATIC ${LIB_SRC})
    add_library(Yder::Yder-static ALIAS yder_static)
    target_include_directories(yder_static
            PUBLIC "$<BUILD_INTERFACE:${INC_DIR}>"
            PUBLIC "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>"
            PUBLIC "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")
    target_compile_definitions(yder_static PUBLIC O_STATIC_LIBRARY)
    set_target_properties(yder_static PROPERTIES
            PUBLIC_HEADER "${INC_DIR}/yder.h;${PROJECT_BINARY_DIR}/yder-cfg.h"
            OUTPUT_NAME yder
            EXPORT_NAME Yder-static)
    if (MSVC)
        set_target_properties(yder_static PROPERTIES
                OUTPUT_NAME yder-static)
    else ()
        target_compile_options(yder_static PRIVATE -Wextra -Wconversion)
    endif ()
    set(yder_lib yder_static)
endif ()

# shared library

if (BUILD_SHARED)
    add_library(yder SHARED ${LIB_SRC})
    add_library(Yder::Yder ALIAS yder)
    target_include_directories(yder
            PUBLIC "$<BUILD_INTERFACE:${INC_DIR}>"
            PUBLIC "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>"
            PUBLIC "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")
    set_target_properties(yder PROPERTIES
            PUBLIC_HEADER "${INC_DIR}/yder.h;${PROJECT_BINARY_DIR}/yder-cfg.h"
            VERSION "${LIBRARY_VERSION}"
            SOVERSION "${LIBRARY_SOVERSION}"
            WINDOWS_EXPORT_ALL_SYMBOLS TRUE
            EXPORT_NAME Yder)
    if (WIN32)
        set_target_properties(yder PROPERTIES
                SUFFIX "-${LIBRARY_VERSION_MAJOR}.dll")
    endif ()
    if (NOT MSVC)
        target_compile_options(yder PRIVATE -Wextra -Wconversion)
    endif ()
    set(yder_lib yder)
endif()

option(DOWNLOAD_DEPENDENCIES "Download required dependencies" ON)

option(SEARCH_ORCANIA "Search for Orcania library" ON)
if (SEARCH_ORCANIA)
    find_package(Orcania ${ORCANIA_VERSION_REQUIRED} QUIET) # try to find orcania
    if (NOT Orcania_FOUND)
        if (DOWNLOAD_DEPENDENCIES)
            include(DownloadProject)
            download_project(PROJ orcania # ... otherwise, download archive
                             URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
                             QUIET)
            add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
            # The following lines can be removed once Orcania has full target support
            if (TARGET orcania)
                if (NOT TARGET Orcania::Orcania)
                    add_library(Orcania::Orcania INTERFACE IMPORTED)
                    set_target_properties(Orcania::Orcania PROPERTIES
                        INTERFACE_INCLUDE_DIRECTORIES "${orcania_SOURCE_DIR};${orcania_SOURCE_DIR}/include;${orcania_BINARY_DIR}"
                        INTERFACE_LINK_LIBRARIES orcania)
                endif ()
            endif ()
            if (TARGET orcania_static)
                if (NOT TARGET Orcania::Orcania-static)
                    add_library(Orcania::Orcania-static INTERFACE IMPORTED)
                    set_target_properties(Orcania::Orcania-static PROPERTIES
                        INTERFACE_INCLUDE_DIRECTORIES "${orcania_SOURCE_DIR};${orcania_SOURCE_DIR}/include;${orcania_BINARY_DIR}"
                        INTERFACE_LINK_LIBRARIES orcania-_static)
                endif ()
            endif ()
        else ()
            message( FATAL_ERROR "Orcania not found")
        endif ()
    else()
        if ("${ORCANIA_VERSION_STRING}" VERSION_GREATER_EQUAL "${ORCANIA_VERSION_REQUIRED}")
            message(STATUS "Orcania found: ${ORCANIA_VERSION_STRING}")
        else ()
            message( FATAL_ERROR "Orcania version required: ${ORCANIA_VERSION_REQUIRED} - version installed: ${ORCANIA_VERSION_STRING}")
        endif ()
    endif ()
else ()
    if (NOT TARGET Orcania::Orcania)
        add_library(Orcania::Orcania INTERFACE IMPORTED)
        set_target_properties(Orcania::Orcania PROPERTIES INTERFACE_LINK_LIBRARIES "orcania")
    endif ()
endif ()

if (BUILD_SHARED)
    target_link_libraries(yder PRIVATE $<TARGET_NAME:Orcania::Orcania> ${SYSTEMD_LIBRARIES})
endif ()
if (BUILD_STATIC)
    if(TARGET Orcania::Orcania-static)
        target_link_libraries(yder_static PRIVATE $<TARGET_NAME:Orcania::Orcania-static> ${SYSTEMD_LIBRARIES})
    else()
        target_link_libraries(yder_static PRIVATE $<TARGET_NAME:Orcania::Orcania> ${SYSTEMD_LIBRARIES})
    endif()
endif ()

set(PKGCONF_REQ_PRIVATE "liborcania")
set(PKGCONF_REQ "")
if (WITH_JOURNALD)
    string(APPEND PKGCONF_REQ_PRIVATE ", libsystemd")
endif ()

# documentation

option(BUILD_YDER_DOCUMENTATION "Build the documentation." OFF)
if (BUILD_YDER_DOCUMENTATION)
    find_package(Doxygen)
    if (DOXYGEN_FOUND)
        set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen.cfg)
        set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)
        
        configure_file(${doxyfile_in} ${doxyfile} @ONLY)
        
        add_custom_target(doc
                          COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile_in}
                          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                          COMMENT "Generating documentation with Doxygen"
                          VERBATIM)

    else ()
        message(FATAL_ERROR "Doxygen is needed to build the documentation.")
    endif ()
endif ()

# build yder-cfg.h file
configure_file(${INC_DIR}/yder-cfg.h.in ${PROJECT_BINARY_DIR}/yder-cfg.h)
set (CMAKE_EXTRA_INCLUDE_FILES ${PROJECT_BINARY_DIR})
include_directories(${PROJECT_BINARY_DIR})

# tests

option(BUILD_YDER_TESTING "Build the testing tree." OFF) # because we don not use include(CTest)

if (BUILD_YDER_TESTING)
    find_package(Check)
    if (CHECK_FOUND)
        if (NOT WIN32 AND NOT APPLE)
            find_package(Subunit REQUIRED)
        endif ()

        enable_testing()

        set(CMAKE_CTEST_COMMAND ctest -V)

        set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
        set(TEST_LIBS ${yder_lib} Check::Check Orcania::Orcania)
        if (NOT WIN32)
            find_package(Threads REQUIRED)
            list(APPEND TEST_LIBS ${CMAKE_THREAD_LIBS_INIT} m)
        endif ()
        if (NOT APPLE)
            list(APPEND TEST_LIBS rt)
        endif ()
        if (NOT WIN32 AND NOT APPLE)
            list(APPEND TEST_LIBS Subunit::Subunit)
        endif ()

        set(TESTS yder_test)

        configure_file(
                "${Y_CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
                "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
                @ONLY)

        foreach (t ${TESTS})
            add_executable(${t} EXCLUDE_FROM_ALL ${TST_DIR}/${t}.c)
            target_include_directories(${t} PRIVATE ${TST_DIR})
            target_link_libraries(${t} PUBLIC ${TEST_LIBS})
            add_test(NAME ${t}
                    WORKING_DIRECTORY ${TST_DIR}
                    COMMAND ${t})
        endforeach ()
    endif ()
endif ()

# install target

option(INSTALL_HEADER "Install the header files" ON) # Install yder.h or not

if(IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}")
  set(PKGCONFIG_TARGET_INCLUDES "${CMAKE_INSTALL_INCLUDEDIR}")
else()
  set(PKGCONFIG_TARGET_INCLUDES "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
endif()

if(IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}")
  set(PKGCONFIG_TARGET_LIBDIR "${CMAKE_INSTALL_LIBDIR}")
else()
  set(PKGCONFIG_TARGET_LIBDIR "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
endif()

configure_file(libyder.pc.in libyder.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libyder.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

set(TARGETS )
if (BUILD_SHARED)
    list(APPEND TARGETS yder)
endif ()
if (BUILD_STATIC)
    list(APPEND TARGETS yder_static)
endif ()

if (INSTALL_HEADER)
    install(TARGETS ${TARGETS} EXPORT YderExports
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
    install(DIRECTORY examples/
            DESTINATION ${CMAKE_INSTALL_DOCDIR}/examples/ COMPONENT runtime)
    install(FILES README.md
            DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT runtime)
else ()
    install(TARGETS ${TARGETS} EXPORT YderExports
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif ()

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # Makefile used to build all programs
 #
-# Copyright 2014-2020 Nicolas Mora <mail@babelouest.org>
+# Copyright 2014-2022 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public License
@@ -35,6 +35,7 @@
 	cd $(LIBYDER_LOCATION) && $(MAKE) clean
 	cd $(EXAMPLE_LOCATION) && $(MAKE) clean
 	cd $(TEST_LOCATION) && $(MAKE) clean
+	rm -rf doc/html/
 
 check:
 	cd $(TEST_LOCATION) && $(MAKE) test

=== src/Makefile ===
--- 
+++ 
@@ -30,12 +30,12 @@
 PKGCONFIG_FILE=../libyder.pc
 PKGCONFIG_TEMPLATE=../libyder.pc.in
 CC=gcc
-CFLAGS+=-c -fPIC -Wall -Werror -Wextra -D_REENTRANT -I$(YDER_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
+CFLAGS+=-c -fPIC -Wall -Werror -Wextra -Wconversion -D_REENTRANT -I$(YDER_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
 LIBS=-lc -lorcania
 OUTPUT=libyder.so
 VERSION_MAJOR=1
 VERSION_MINOR=4
-VERSION_PATCH=17
+VERSION_PATCH=19
 
 SONAME = -soname
 ifeq ($(shell uname -s),Darwin)

=== debian/changelog ===
yder (1.4.19-1) unstable; urgency=medium

  [Nicolas Mora]
  * New upstream release
  * d/control: Update Standards-Version to 4.6.2
  * d/libyder-dev.install: Add cmake dependencies
  * d/copyright: Update copyright year to 2023 for debian/* files

  [Debian Janitor]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on autopkgtest.

 -- Nicolas Mora <babelouest@debian.org>  Sun, 08 Jan 2023 09:39:56 -0500

yder (1.4.18-1) unstable; urgency=medium

  * New upstream release
  * d/control: upgrade standards version to 4.6.1

 -- Nicolas Mora <babelouest@debian.org>  Sat, 15 Oct 2022 17:13:51 -0400

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
           , Nicolas Mora <babelouest@debian.org>
 Build-Depends: debhelper-compat (= 13)
-	, autopkgtest (>= 5.6~)
+	, autopkgtest
 	, liborcania-dev (>= 2.2.2)
 	, libsystemd-dev [linux-any]
 	, cmake
 	, check
 	, doxygen
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/babelouest/yder
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/yder.git
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/yder.git

=== debian/rules ===
--- 
+++ 
@@ -23,15 +23,13 @@
 %:
 	dh $@ --buildsystem=cmake --builddirectory=build
 
-override_dh_auto_install:
-	echo dh_auto_install
-
 override_dh_auto_configure:
-	dh_auto_configure -- $(ARGS) -DBUILD_YDER_TESTING=ON \
-                               -DINSTALL_HEADER=ON \
-                               -DDOWNLOAD_DEPENDENCIES=OFF \
-                               --no-warn-unused-cli
-	dh_installexamples --
+	dh_auto_configure -- $(ARGS) \
+						-DSKIP_BUILD_RPATH=TRUE \
+						-DBUILD_YDER_TESTING=ON \
+						-DINSTALL_HEADER=ON \
+						-DDOWNLOAD_DEPENDENCIES=OFF \
+						--no-warn-unused-cli
 
 override_dh_auto_build:
 	doxygen doc/doxygen.cfg
